function ZombieDefense:StartActivity()
	print("Zombie Defense Activity Start");
	self.FightStage = { NOFIGHT = 0, DEFENDING = 1, ATTACK = 2, FIGHTSTAGECOUNT = 3 };
	self.zspawn1 = Timer();
	self.zspawn2 = Timer();
	self.zspawn3 = Timer();
	self.zspawn4 = Timer();
	self.zspawn5 = Timer();
	self.zspawn6 = Timer();
	self.gametime = Timer();
	self.gametime:SetRealTimeLimitS(30);
	self.gameover = 0;
	self.ztime = 5000;
	self.InterruptTimer = Timer();
	self.Interrupt = 0;
	ActivityMan:GetActivity():SetTeamFunds(0,0);
	playerActor = CreateAHuman("Soldier Heavy");
	playerActor.Pos = Vector(2508,876);
	playerActor.Team = 0;
	self:SetPlayerBrain(playerActor, 0);
	self:SetLandingZone(playerActor.Pos, 0);
	playerActor:AddInventoryItem(CreateHDFirearm("Lady Pistol"));
	playerActor:AddInventoryItem(CreateTDExplosive("Frag Grenade"));
	MovableMan:AddActor(playerActor);
	self:SwitchToActor(playerActor, 0, self:GetTeamOfPlayer(0));
	zlist = {"Spewer Thin","Spewer Medium","Spewer Fat"};
	wlist = {"Vomit Gun"};
	blist = {"Stone"};
	zombiecount = 0;
	zombiecap = 10;
	killcount = 300;
	zdouble = 0;
	dt = 0;
	pickup1 = 0;
	pickup2 = 0;
	pickup3 = 0;
	pickup4 = 0;
	pickup5 = 0;
	pickup6 = 0;
	pickup7 = 0;
	pickup8 = 0;
end
	
function ZombieDefense:PauseActivity()
	print("Zombie Defense Activity Paused");
end

function ZombieDefense:EndActivity()
	print("Zombie Defense GAME OVER");
	self.gameover = 1;
	if self.WinnerTeam == Activity.TEAM_2 then
        FrameMan:ClearScreenText(Activity.PLAYER_1);
		FrameMan:SetScreenText("The ravenous zombies proved too much for the lone survivor... All hope had been lost...", Activity.PLAYER_1, 0, 5000, false);
	else
        FrameMan:ClearScreenText(Activity.PLAYER_1);
		FrameMan:SetScreenText("My god, you withstood the onslaught of ONE THOUSAND zombies. You is a champeen.", Activity.PLAYER_1, 0, 5000, false);
	end
end

function ZombieDefense:UpdateActivity()
	if MovableMan:IsActor(playerActor) then
		self:SetObservationTarget(playerActor.Pos, Activity.PLAYER_1);
	end
	
	if playerActor.Health == 0 then
		self.WinnerTeam = Activity.TEAM_2;
		ActivityMan:EndActivity();
	end

	if zombiecount < zombiecap then
		if -self.zspawn1:LeftTillSimMS(0) > self.ztime then
			local zombie1 = CreateAHuman(zlist[math.random(#zlist)]);
			zombie1:AddAISceneWaypoint(Vector(3000,playerActor.Pos.Y));
			zombie1.Pos = Vector(400,850);
			zombie1.Team = 1;
			zombie1.AIMode = Actor.AIMODE_GOTO;
			zombie1:AddInventoryItem(CreateHDFirearm(wlist[math.random(#wlist)]));
			zombie1:AddInventoryItem(CreateTDExplosive(blist[math.random(#blist)]));
			MovableMan:AddActor(zombie1);
			self.zspawn1:Reset();
			zombiecount = zombiecount + 1;
		end
		if -self.zspawn2:LeftTillSimMS(0) > self.ztime then
			local zombie2 = CreateAHuman(zlist[math.random(#zlist)]);
			zombie2:AddAISceneWaypoint(Vector(3000,playerActor.Pos.Y));
			zombie2.Pos = Vector(1200,850);
			zombie2.Team = 1;
			zombie2.AIMode = Actor.AIMODE_GOTO;
			zombie2:AddInventoryItem(CreateTDExplosive(blist[math.random(#blist)]));
			zombie2:AddInventoryItem(CreateHDFirearm(wlist[math.random(#wlist)]));
			MovableMan:AddActor(zombie2);
			self.zspawn2:Reset();
			zombiecount = zombiecount + 1;
		end
		if -self.zspawn3:LeftTillSimMS(0) > self.ztime then
			local zombie3 = CreateAHuman(zlist[math.random(#zlist)]);
			zombie3:AddAISceneWaypoint(Vector(3000,playerActor.Pos.Y));
			zombie3.Pos = Vector(2000,850);
			zombie3.Team = 1;
			zombie3.AIMode = Actor.AIMODE_GOTO;
			zombie3:AddInventoryItem(CreateHDFirearm(wlist[math.random(#wlist)]));
			zombie3:AddInventoryItem(CreateTDExplosive(blist[math.random(#blist)]));
			MovableMan:AddActor(zombie3);
			self.zspawn3:Reset();
			zombiecount = zombiecount + 1;
		end
	end
	if zombiecount < zombiecap and zdouble > 0 then
		if -self.zspawn4:LeftTillSimMS(0) > self.ztime then
			local zombie4 = CreateAHuman(zlist[math.random(#zlist)]);
			zombie4:AddAISceneWaypoint(Vector(3000,playerActor.Pos.Y));
			zombie4.Pos = Vector(4900,850);
			zombie4.Team = 1;
			zombie4.AIMode = Actor.AIMODE_GOTO;
			zombie4:AddInventoryItem(CreateHDFirearm(wlist[math.random(#wlist)]));
			zombie4:AddInventoryItem(CreateTDExplosive(blist[math.random(#blist)]));
			MovableMan:AddActor(zombie4);
			self.zspawn4:Reset();
			zombiecount = zombiecount + 1;
		end
		if -self.zspawn5:LeftTillSimMS(0) > self.ztime then
			local zombie5 = CreateAHuman(zlist[math.random(#zlist)]);
			zombie5:AddAISceneWaypoint(Vector(3000,playerActor.Pos.Y));
			zombie5.Pos = Vector(4100,850);
			zombie5.Team = 1;
			zombie5.AIMode = Actor.AIMODE_GOTO;
			zombie5:AddInventoryItem(CreateHDFirearm(wlist[math.random(#wlist)]));
			zombie5:AddInventoryItem(CreateTDExplosive(blist[math.random(#blist)]));
			MovableMan:AddActor(zombie5);
			self.zspawn5:Reset();
			zombiecount = zombiecount + 1;
		end
		if -self.zspawn6:LeftTillSimMS(0) > self.ztime then
			local zombie6 = CreateAHuman(zlist[math.random(#zlist)]);
			zombie6:AddAISceneWaypoint(Vector(3000,playerActor.Pos.Y));
			zombie6.Pos = Vector(3300,850);
			zombie6.Team = 1;
			zombie6.AIMode = Actor.AIMODE_GOTO;
			zombie6:AddInventoryItem(CreateHDFirearm(wlist[math.random(#wlist)]));
			zombie6:AddInventoryItem(CreateTDExplosive(blist[math.random(#blist)]));
			MovableMan:AddActor(zombie6);
			self.zspawn6:Reset();
			zombiecount = zombiecount + 1;
		end
	end
	
	for actor in MovableMan.Actors do
        if SceneMan.Scene:WithinArea("Boundary", actor.Pos) then
			if actor.Team == 0 then
				actor.Vel = actor.Vel * -1;
			end
        end
    end
	
	for item in MovableMan.Items do
		if item.PresetName == "Vomit Gun" then
			item.ToSettle = true;
		end
		if item.PresetName == "Stone" then
			item.ToSettle = true;
		end
	end
	
	if killcount >= 25 and pickup1 == 0 then
		playerActor:AddInventoryItem(CreateHDFirearm("Auto Pistol"));
		playerActor:AddInventoryItem(CreateTDExplosive("Frag Grenade"));
		self.Interrupt = 5000;
		self.InterruptTimer:Reset();
		self:ResetMessageTimer(Activity.PLAYER_1);
        FrameMan:ClearScreenText(Activity.PLAYER_1);
		FrameMan:SetScreenText("LEVEL TWO! +1 Frag Grenade! Auto Pistol unlocked!", Activity.PLAYER_1, 0, 5000, false);
		pickup1 = 1;
		zombiecap = 20;
	end

	if killcount >= 50 and pickup2 == 0 then
		playerActor:AddInventoryItem(CreateHDFirearm("Laser Rifle"));
		self.Interrupt = 5000;
		self.InterruptTimer:Reset();
		self:ResetMessageTimer(Activity.PLAYER_1);
        FrameMan:ClearScreenText(Activity.PLAYER_1);
		FrameMan:SetScreenText("LEVEL THREE! Laser Rifle unlocked!", Activity.PLAYER_1, 0, 5000, false);
		pickup2 = 1;
		self.ztime = 4500;
	end
	
	if killcount >= 75 and pickup3 == 0 then
		playerActor:AddInventoryItem(CreateHDFirearm("AK-47"));
		playerActor:AddInventoryItem(CreateTDExplosive("Frag Grenade"));
		playerActor:AddInventoryItem(CreateTDExplosive("Frag Grenade"));
		playerActor:AddInventoryItem(CreateTDExplosive("Frag Grenade"));
		self.Interrupt = 5000;
		self.InterruptTimer:Reset();
		self:ResetMessageTimer(Activity.PLAYER_1);
        FrameMan:ClearScreenText(Activity.PLAYER_1);
		FrameMan:SetScreenText("LEVEL FOUR! +3 Frag Grenades! AK-47 unlocked!", Activity.PLAYER_1, 0, 5000, false);
		pickup3 = 1;
		self.ztime = 4000;
	end
	
	if killcount >= 100 and pickup4 == 0 then
		playerActor:AddInventoryItem(CreateHDFirearm("Heavy Sniper Rifle"));
		self.Interrupt = 5000;
		self.InterruptTimer:Reset();
		self:ResetMessageTimer(Activity.PLAYER_1);
        FrameMan:ClearScreenText(Activity.PLAYER_1);
		FrameMan:SetScreenText("LEVEL FIVE! Heavy Sniper Rifle unlocked!", Activity.PLAYER_1, 0, 5000, false);
		pickup4 = 1;
		zombiecap = 40;
		self.ztime = 3000;
		if playerActor.Health < 100 then
			self.Interrupt = 5000;
			self.InterruptTimer:Reset();
			self:ResetMessageTimer(Activity.PLAYER_1);
			FrameMan:ClearScreenText(Activity.PLAYER_1);
			FrameMan:SetScreenText("LEVEL FIVE! Health Bonus! Heavy Sniper Rifle unlocked!", Activity.PLAYER_1, 0, 5000, false);
			playerActor.Health = playerActor.Health + 30;
		end
	end
	
	if killcount >= 125 and dt == 0 then
		zdouble = 1;
		self.Interrupt = 5000;
		self.InterruptTimer:Reset();
		self:ResetMessageTimer(Activity.PLAYER_1);
        FrameMan:ClearScreenText(Activity.PLAYER_1);
		FrameMan:SetScreenText("DOUBLE TROUBLE!  ..UH OH! Now they are coming from both sides!! ", Activity.PLAYER_1, 0, 5000, false);
		dt = 1;
	end

	if killcount >= 150 and pickup5 == 0 then
		playerActor:AddInventoryItem(CreateHDFirearm("M1600"));
		playerActor:AddInventoryItem(CreateTDExplosive("Pineapple Grenade"));
		self.Interrupt = 5000;
		self.InterruptTimer:Reset();
		self:ResetMessageTimer(Activity.PLAYER_1);
        FrameMan:ClearScreenText(Activity.PLAYER_1);
		FrameMan:SetScreenText("LEVEL SIX! +1 Pineapple Grenade! M1600 unlocked!", Activity.PLAYER_1, 0, 5000, false);
		pickup5 = 1;
		self.ztime = 2500;
	end
	
	if killcount >= 300 and pickup6 == 0 then
		playerActor:AddInventoryItem(CreateHDFirearm("Mauler Shotgun"));
		self.Interrupt = 5000;
		self.InterruptTimer:Reset();
		self:ResetMessageTimer(Activity.PLAYER_1);
        FrameMan:ClearScreenText(Activity.PLAYER_1);
		FrameMan:SetScreenText("LEVEL SEVEN! Mauler Shotgun unlocked!", Activity.PLAYER_1, 0, 5000, false);
		pickup6 = 1;
		zombiecap = 60;
		self.ztime = 2000;
	end
	
	if killcount >= 500 and pickup7 == 0 then
		playerActor:AddInventoryItem(CreateHDFirearm("Rocket Launcher"));
		playerActor:AddInventoryItem(CreateTDExplosive("Molotov Cocktail"));
		self.Interrupt = 5000;
		self.InterruptTimer:Reset();
		self:ResetMessageTimer(Activity.PLAYER_1);
        FrameMan:ClearScreenText(Activity.PLAYER_1);
		FrameMan:SetScreenText("LEVEL EIGHT! +1 Molotov Cocktail! Rocket launcher unlocked!", Activity.PLAYER_1, 0, 5000, false);
		pickup7 = 1;
		self.ztime = 1500;
		if playerActor.Health < 100 then
			self.Interrupt = 5000;
			self.InterruptTimer:Reset();
			self:ResetMessageTimer(Activity.PLAYER_1);
			FrameMan:ClearScreenText(Activity.PLAYER_1);
			FrameMan:SetScreenText("LEVEL EIGHT! Health Bonus! +1 Molotov Cocktail! Rocket launcher unlocked!", Activity.PLAYER_1, 0, 5000, false);
			playerActor.Health = playerActor.Health + 50;
		end
	end
	
	if killcount >= 750 and pickup8 == 0 then
		playerActor:AddInventoryItem(CreateHDFirearm("Gatling Gun"));
		playerActor:AddInventoryItem(CreateTDExplosive("Incendiary Grenade"));
		self.Interrupt = 5000;
		self.InterruptTimer:Reset();
		self:ResetMessageTimer(Activity.PLAYER_1);
        FrameMan:ClearScreenText(Activity.PLAYER_1);
		FrameMan:SetScreenText("LEVEL NINE! +1 Incendiary Grenade! Gatling gun unlocked!", Activity.PLAYER_1, 0, 5000, false);
		pickup8 = 1;
		self.ztime = 1000;
		zombiecap = 80;
	end

	if killcount >= 1000 then
		self.WinnerTeam = Activity.TEAM_1;
		ActivityMan:EndActivity();
	end
end
	